var mcft = {

	hookFunc: function(obj, name, matchCode, replaceCode) {
		try {
			if (typeof(obj) == "string") {
				obj = document.getElementById(obj);
			}
			if (typeof(matchCode) == "string") {
				matchCode = RegExp(matchCode.replace(/[{[(\\^.$|?*+/)\]}]/g, "\\$&").replace(/[{;}]/g, "$&\\s*"));
			}
			var orgCode = obj[name].toString();
			var newCode = obj[name].toString().replace(matchCode, replaceCode);
			if (orgCode == newCode) {
				throw "MatchError:\n@matchCode: "+matchCode;
			} else {
				eval("obj[name]="+newCode);
			}
		} catch(ex) { Components.utils.reportError("[MClickFocusTab] Failed to hook function: <"+obj+"."+name+"> "+ex+"\n"+newCode); }
	},

	hookProp: function(obj, name, matchGetter, replaceGetter, matchSetter, replaceSetter) {
		try {
			var orgGetter = obj.__lookupGetter__(name).toString();
			var orgSetter = obj.__lookupSetter__(name).toString();
			var newGetter = (matchGetter ? orgGetter.replace(matchGetter, replaceGetter) : orgGetter);
			var newSetter = (matchSetter ? orgSetter.replace(matchSetter, replaceSetter) : orgSetter);
			if ((orgGetter == newGetter) && (orgSetter == newSetter)) {
				throw "MatchError:\n@matchGetter: "+matchGetter+"\n@matchSetter: "+matchSetter;
			} else {
				eval("obj.__defineGetter__(name, "+ newGetter.toString() +");");
				eval("obj.__defineSetter__(name, "+ newSetter.toString() +");");
			}
		} catch(ex) { Components.utils.reportError("[MClickFocusTab] Failed to hook property: <"+obj+"."+name+"> "+ex+"\n<Getter>"+newGetter+"\n<Setter>"+newSetter); }
	},

	MCLICK_STATE_NONE: 0,
	MCLICK_STATE_DOWN: 1,
	MCLICK_STATE_HOLD: 2,
	MCLICK_STATE_SKIP: 4,

	_state: 0,
	_target: null,
	_style: null,

	highlight: function(target) {
		if (mcft._target) {
			mcft._target.setAttribute("style", mcft._style);
			mcft._target = null;
			mcft._style = null;
		}
		if (target && target.style && (mcft._state == mcft.MCLICK_STATE_HOLD)) {
			if (nsPreferences.getBoolPref("extensions.mclickfocustab.highlight", true)) {
				mcft._target = target;
				mcft._style = mcft._target.getAttribute("style");
				mcft._target.setAttribute("style", nsPreferences.copyUnicharPref("extensions.mclickfocustab.highlight.style", "opacity: 0.7;"));
			}
		}
	},

	// implement: middle-click focus tab
	get prefFocusTabSTATE() {
		return nsPreferences.getIntPref("extensions.mclickfocustab.focustab", mcft.MCLICK_STATE_HOLD);
	},

	initFocusTab: function() {
		window.addEventListener("mousedown", function(event) {
			if (event && event.button == 1) {
				if (event.target.localName != "tabbrowser") {
					if (mcft._timer) { window.clearTimeout(mcft._timer); mcft._timer = null; }
					mcft._state = mcft.MCLICK_STATE_DOWN;
					mcft._timer = window.setTimeout(function() {
						if (mcft._state == mcft.MCLICK_STATE_DOWN) {
							mcft._state = mcft.MCLICK_STATE_HOLD;
							mcft.highlight(event.target);
							if (!nsPreferences.getBoolPref("extensions.mclickfocustab.aftermouseup", true)) {
								var evt = document.createEvent("MouseEvents");
								evt.initMouseEvent("click",
									event.bubbles, event.cancelable,
									event.view, event.detail,
									event.screenX, event.screenY,
									event.clientX, event.clientY,
									event.ctrlKey, event.altKey, event.shiftKey, event.metaKey,
									event.button, null);
								event.target.dispatchEvent(evt);
								mcft._state = mcft._state | mcft.MCLICK_STATE_SKIP;
							}
						}
					}, nsPreferences.getIntPref("extensions.mclickfocustab.timeout", 300));
				}
			}
		}, true);

		window.addEventListener("mouseup", function(event) {
			window.setTimeout(function(){
				if (mcft._timer) { window.clearTimeout(mcft._timer); mcft._timer = null; }
				mcft._state = mcft.MCLICK_STATE_NONE;
				mcft.highlight();
			}, 0);
		}, true);

		window.addEventListener("click", function(event) {
			if (mcft._state & mcft.MCLICK_STATE_SKIP) {
				event.preventDefault();
				event.stopPropagation();
			}
		}, true);

		mcft.hookFunc(gBrowser, "addTab",
			/^([^{]*){([\S\s]*)}\s*$/,
			<><![CDATA[
			$1 {
				try {
					$2
				} finally {
					if (mcft._state == mcft.prefFocusTabSTATE) { this.selectedTab = t; }
					if (mcft._state != mcft.MCLICK_STATE_NONE) { mcft._state = mcft._state | mcft.MCLICK_STATE_SKIP; }
				}
			}
			]]></>
		);

		mcft.hookProp(gBrowser, "selectedTab",
			null,
			null,
			/{/,
			<><![CDATA[
				$&
				if ((mcft._state & mcft.MCLICK_STATE_SKIP) && this.selectedTab && (this.visibleTabs.length > 1)) return val;
			]]></>
		);
	},

	// implement: stay-open menu
	get prefStayOpenSTATE() {
		return nsPreferences.getIntPref("extensions.mclickfocustab.stayopenmenu", mcft.MCLICK_STATE_DOWN);
	},

	initStayOpenMenu: function() {
		window.addEventListener("popuphiding", function(event) {
			if (mcft._state & mcft.prefStayOpenSTATE) {
				if (event.target.localName == "menupopup") {
					event.preventDefault();
				}
			}
		}, true);

		mcft.hookFunc(gBrowser, "updateCurrentBrowser",
			"this.mCurrentTab.dispatchEvent(event);",
			"$& if ((mcft._state & mcft.prefStayOpenSTATE) && this.selectedTab) return;"
		);

		mcft.hookFunc("PopupAutoCompleteRichResult", "onPopupClick",
			"this.closePopup();controller.handleEscape();",
			"if (!(mcft._state & mcft.prefStayOpenSTATE)) { $& }"
		);

		mcft.hookFunc(window, "openLinkIn",
			"w.content.focus();",
			"if (!(mcft._state & mcft.prefStayOpenSTATE)) { $& }"
		);
	},

	init: function() {
		["initFocusTab", "initStayOpenMenu"].forEach(function(fn){ mcft[fn](); });
		["initFocusTab", "initStayOpenMenu", "hookFunc", "hookProp"].forEach(function(fn){ delete mcft[fn]; });
	}
}

window.addEventListener("load", function() {
	window.removeEventListener("load", arguments.callee, false);
	window.setTimeout(mcft.init, 100);
	delete mcft.init;
}, false);
